{    var   : }
{ M, K }
Unit de80ei_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE70EC_p, DE70EQ_p;

procedure de80ei(F :Proc_F80E; var M :Integer; var K :Integer;
                IEXIT :Integer; var YX :Array of Extended;
                var DYX :Array of Extended; var XJ0 :Array of Extended;
                var AJK :Array of Extended; var HD4I :Array of Extended;
                var RABC :Array of Extended; var RABC1 :Array of Extended;
                var RABC2 :Array of Extended;
                var RABC3 :Array of Extended; var ALPN :Array of Extended;
                var CMAR :Array of Extended; var AU :Array of Extended;
                var ADU :Array of Extended; var U :Array of Extended;
                var DU :Array of Extended; var ZFI :Array of Extended);

implementation

procedure de80ei(F :Proc_F80E; var M :Integer; var K :Integer;
                IEXIT :Integer; var YX :Array of Extended;
                var DYX :Array of Extended; var XJ0 :Array of Extended;
                var AJK :Array of Extended; var HD4I :Array of Extended;
                var RABC :Array of Extended; var RABC1 :Array of Extended;
                var RABC2 :Array of Extended;
                var RABC3 :Array of Extended; var ALPN :Array of Extended;
                var CMAR :Array of Extended; var AU :Array of Extended;
                var ADU :Array of Extended; var U :Array of Extended;
                var DU :Array of Extended; var ZFI :Array of Extended);
var
KM1,KM2,KP1,KP2,KP3,L,J,JL,I,IP1,IP2,IM1,IP3 :Integer;
label
_10,_15,_20,_22,_25,_30,_31,_32,_35,_40,_45,_50,_55,_60,_65,_70,_75,
_80,_81,_85,_90,_91,_92,_93,_95,_96,_97,_98,_99,_100,_110,_115,_116,
_120,_125,_130;
begin
KM1 := K-1;
KM2 := K-2;
KP1 := K+1;
KP2 := K+2;
KP3 := K+3;
for L:=1 to M do
 begin
_10:
  AU[(L-1)+1*M] := 0.0;
 end;
{  }
{     CALCULATION SUM SIGMA }
{  }
J := 2;
while ( J<=K ) do
 begin
  JL := _COM80D.elm1-J;
  for L:=1 to M do
   begin
_15:
    AU[(L-1)+1*M] := AU[(L-1)+1*M]-AJK[(L-1)+(JL+0)*M]*RABC[JL-1];
   end;
_20:
  inc(J,2);
 end;
{  }
if ( K = 2 )
 then goto _32;
{  }
{    THE COLUMN AU(L,3) IS USED AS WORKING ARRAY }
{  }
for L:=1 to M do
 begin
_22:
  AU[(L-1)+2*M] := 0.0;
 end;
{  }
J := 3;
while ( J<=K ) do
 begin
  JL := _COM80D.elm2-J;
  for L:=1 to M do
   begin
_25:
    AU[(L-1)+2*M] := AU[(L-1)+2*M]+AJK[(L-1)+(JL+0)*M]*RABC[JL-1];
   end;
_30:
  inc(J,2);
 end;
{  }
for L:=1 to M do
 begin
_31:
  AU[(L-1)+1*M] := AU[(L-1)+1*M]+AU[(L-1)+2*M];
 end;
{ ------------------------------------------------------- };
_32:
for L:=1 to M do
 begin
  ADU[(L-1)+0*M] := (DYX[L-1]+_COM70D.elm6*(AJK[(L-1)+0*M]-0.5e0*AJK[(L-1)+1*M])+_COM70D.elm5*AU[(L-1)+1*M])*2.0e0;
  ADU[(L-1)+(KP1-1)*M] := HD4I[K-1]*AJK[(L-1)+(K-1)*M];
  ADU[(L-1)+(KP2-1)*M] := HD4I[KP1-1]*AJK[(L-1)+(KP1-1)*M];
_35:
 end;
for I:=1 to KM1 do
 begin
  IP1 := I+1;
  IP2 := I+2;
  for L:=1 to M do
   begin
_40:
    ADU[(L-1)+(IP1-1)*M] := HD4I[I-1]*(AJK[(L-1)+(I-1)*M]-AJK[(L-1)+(IP2-1)*M]);
   end;
_45:
 end;
{  }
{     CALCULATION SUM OF LAST TWO TERMS FOR J=K AND J=K-1 }
{  }
if ( ((K) Mod (2)) ) < 0
 then goto _60
 else if ( ((K) Mod (2)) ) > 0
       then goto _60
       else goto _50;
_50:
for L:=1 to M do
 begin
_55:
  AU[(L-1)+0*M] := RABC1[KM1-1]*AJK[(L-1)+(K-1)*M]-RABC1[K-1]*AJK[(L-1)+(KP1-1)*M];
 end;
goto _70;
_60:
for L:=1 to M do
 begin
_65:
  AU[(L-1)+0*M] := -RABC1[KM1-1]*AJK[(L-1)+(K-1)*M]+RABC1[K-1]*AJK[(L-1)+(KP1-1)*M];
 end;
{ ------------------------------------------------------- };
_70:
if ( K = 2 ) 
 then goto _95;
if ( K = 3 )
 then goto _92;
{  }
{    CALCULATION THE LAST SUM }
{  }
J := 2;
while ( J<=KM2 ) do
 begin
  JL := _COM80D.elm3-J;
  for L:=1 to M do
   begin
_75:
    AU[(L-1)+0*M] := AU[(L-1)+0*M]-RABC1[JL-1]*(AJK[(L-1)+(JL+0)*M]-AJK[(L-1)+(JL+2)*M]);
   end;
_80:
  inc(J,2);
 end;
{  }
{    CONTINUATION OF CALCULATION THE LAST SUM }
{  }
{    THE COLUMN AU(L,3) IS USED AS WORKING ARRAY }
{  }
for L:=1 to M do
 begin
_81:
  AU[(L-1)+2*M] := 0.0;
 end;
J := 1;
while ( J<=KM2 ) do
 begin
  JL := _COM80D.elm4-J;
  for L:=1 to M do
   begin
_85:
    AU[(L-1)+2*M] := AU[(L-1)+2*M]+RABC1[JL-1]*(AJK[(L-1)+(JL+0)*M]-AJK[(L-1)+(JL+2)*M]);
   end;
_90:
  inc(J,2);
 end;
{  }
for L:=1 to M do
 begin
_91:
  AU[(L-1)+0*M] := AU[(L-1)+0*M]+AU[(L-1)+2*M];
 end;
goto _95;
{  }
{     CASE (EVENT) FOR K=3 }
{  };
_92:
for L:=1 to M do
 begin
_93:
  AU[(L-1)+0*M] := AU[(L-1)+0*M]+RABC1[0]*(AJK[(L-1)+1*M]-AJK[(L-1)+3*M]);
 end;
{ -------------------------------------------------------- }
{ -------------------------------------------------------- };
_95:
for L:=1 to M do
 begin
  AU[(L-1)+0*M] := (YX[L-1]+_COM70D.elm5*DYX[L-1]+_COM80D.elm8*(3.0e0*AJK[(L-1)+0*M]-2.0e0*AJK[(L-1)+1*M]+
    AJK[(L-1)+2*M])+_COM80D.elm5*AU[(L-1)+1*M]-_COM80D.elm6*AU[(L-1)+0*M])*2.0e0;
{  }
  if ( K = 2 ) 
   then goto _96;
{  }
  AU[(L-1)+1*M] := _COM70D.elm5*(DYX[L-1]+_COM70D.elm6*(AJK[(L-1)+0*M]-0.75e0*AJK[(L-1)+1*M]+
    0.25e0*AJK[(L-1)+3*M])+_COM70D.elm5*AU[(L-1)+1*M]);
  goto _97;
{  };
_96:
  AU[(L-1)+1*M] := _COM70D.elm5*(DYX[L-1]+_COM70D.elm6*(AJK[(L-1)+0*M]-0.75e0*AJK[(L-1)+1*M])+
    _COM70D.elm5*AU[(L-1)+1*M]);
  goto _99;
{  };
_97:
  if ( K = 3 ) 
   then goto _98;
{  }
  AU[(L-1)+2*M] := _COM80D.elm9*(3.0e0*AJK[(L-1)+0*M]-4.0e0*AJK[(L-1)+2*M]+AJK[(L-1)+4*M]);
_98:
  AU[(L-1)+(K-1)*M] := _COM80D.elm7*(RABC2[KM1-1]*AJK[(L-1)+(KM2-1)*M]-RABC3[KM1-1]*AJK[(L-1)+(K-1)*M]);
_99:
  AU[(L-1)+(KP1-1)*M] := _COM80D.elm7*(RABC2[K-1] *AJK[(L-1)+(KM1-1)*M]-RABC3[K-1]  *AJK[(L-1)+(KP1-1)*M]);
  AU[(L-1)+(KP2-1)*M] := _COM80D.elm7*RABC2[KP1-1]*AJK[(L-1)+(K-1)*M];
  AU[(L-1)+(KP3-1)*M] := _COM80D.elm7*RABC2[KP2-1]*AJK[(L-1)+(KP1-1)*M];
_100:
 end;
{  }
if ( K < 5 )
 then goto _116;
for I:=3 to KM2 do
 begin
  IM1 := I-1;
  IP1 := I+1;
  IP3 := I+3;
  for L:=1 to M do
   begin
_110:
    AU[(L-1)+(IP1-1)*M] := _COM80D.elm7*(RABC2[I-1]*AJK[(L-1)+(IM1-1)*M]-RABC3[I-1]*AJK[(L-1)+(IP1-1)*M]+
    RABC2[IP1-1]*AJK[(L-1)+(IP3-1)*M]);
   end;
_115:
 end;
{  }
_116:
if ( IEXIT = 1 )
 then goto _130;
for J:=1 to K do
 begin
  DE70EC(M,KP1,ALPN[J-1],ADU,DU[(J-1)*M],ZFI[(KP2-1)*M]);
  DE70EC(M,KP2,ALPN[J-1],AU,  U[(J-1)*M],ZFI[(KP2-1)*M]);
_120:
 end;
if ( IEXIT = 2 ) 
 then goto _130;
for J:=1 to K do
 begin
  F(XJ0[J-1],U[(J-1)*M],DU[(J-1)*M],ZFI[(J+0)*M],M);
_125:
 end;
if ( IEXIT = 3 ) 
 then goto _130;
DE70EQ(M,K,ZFI,CMAR,AJK);
_130:
end;

end.
